]> git.ipfire.org Git - thirdparty/git.git/blob - git-submodule.sh
t7419: change test_must_fail to ! for grep
[thirdparty/git.git] / git-submodule.sh
1 #!/bin/sh
2 #
3 # git-submodule.sh: add, init, update or list git submodules
4 #
5 # Copyright (c) 2007 Lars Hjemli
6
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] set-branch (--default|--branch <branch>) [--] <path>
14 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15 or: $dashless [--quiet] foreach [--recursive] <command>
16 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
17 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
18 OPTIONS_SPEC=
19 SUBDIRECTORY_OK=Yes
20 . git-sh-setup
21 . git-parse-remote
22 require_work_tree
23 wt_prefix=$(git rev-parse --show-prefix)
24 cd_to_toplevel
25
26 # Tell the rest of git that any URLs we get don't come
27 # directly from the user, so it can apply policy as appropriate.
28 GIT_PROTOCOL_FROM_USER=0
29 export GIT_PROTOCOL_FROM_USER
30
31 command=
32 branch=
33 force=
34 reference=
35 cached=
36 recursive=
37 init=
38 files=
39 remote=
40 nofetch=
41 update=
42 prefix=
43 custom_name=
44 depth=
45 progress=
46 dissociate=
47
48 die_if_unmatched ()
49 {
50 if test "$1" = "#unmatched"
51 then
52 exit ${2:-1}
53 fi
54 }
55
56 #
57 # Print a submodule configuration setting
58 #
59 # $1 = submodule name
60 # $2 = option name
61 # $3 = default value
62 #
63 # Checks in the usual git-config places first (for overrides),
64 # otherwise it falls back on .gitmodules. This allows you to
65 # distribute project-wide defaults in .gitmodules, while still
66 # customizing individual repositories if necessary. If the option is
67 # not in .gitmodules either, print a default value.
68 #
69 get_submodule_config () {
70 name="$1"
71 option="$2"
72 default="$3"
73 value=$(git config submodule."$name"."$option")
74 if test -z "$value"
75 then
76 value=$(git submodule--helper config submodule."$name"."$option")
77 fi
78 printf '%s' "${value:-$default}"
79 }
80
81 isnumber()
82 {
83 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
84 }
85
86 # Given a full hex object ID, is this the zero OID?
87 is_zero_oid () {
88 echo "$1" | sane_egrep '^0+$' >/dev/null 2>&1
89 }
90
91 # Sanitize the local git environment for use within a submodule. We
92 # can't simply use clear_local_git_env since we want to preserve some
93 # of the settings from GIT_CONFIG_PARAMETERS.
94 sanitize_submodule_env()
95 {
96 save_config=$GIT_CONFIG_PARAMETERS
97 clear_local_git_env
98 GIT_CONFIG_PARAMETERS=$save_config
99 export GIT_CONFIG_PARAMETERS
100 }
101
102 #
103 # Add a new submodule to the working tree, .gitmodules and the index
104 #
105 # $@ = repo path
106 #
107 # optional branch is stored in global branch variable
108 #
109 cmd_add()
110 {
111 # parse $args after "submodule ... add".
112 reference_path=
113 while test $# -ne 0
114 do
115 case "$1" in
116 -b | --branch)
117 case "$2" in '') usage ;; esac
118 branch=$2
119 shift
120 ;;
121 -f | --force)
122 force=$1
123 ;;
124 -q|--quiet)
125 GIT_QUIET=1
126 ;;
127 --progress)
128 progress=1
129 ;;
130 --reference)
131 case "$2" in '') usage ;; esac
132 reference_path=$2
133 shift
134 ;;
135 --reference=*)
136 reference_path="${1#--reference=}"
137 ;;
138 --dissociate)
139 dissociate=1
140 ;;
141 --name)
142 case "$2" in '') usage ;; esac
143 custom_name=$2
144 shift
145 ;;
146 --depth)
147 case "$2" in '') usage ;; esac
148 depth="--depth=$2"
149 shift
150 ;;
151 --depth=*)
152 depth=$1
153 ;;
154 --)
155 shift
156 break
157 ;;
158 -*)
159 usage
160 ;;
161 *)
162 break
163 ;;
164 esac
165 shift
166 done
167
168 if ! git submodule--helper config --check-writeable >/dev/null 2>&1
169 then
170 die "$(eval_gettext "please make sure that the .gitmodules file is in the working tree")"
171 fi
172
173 if test -n "$reference_path"
174 then
175 is_absolute_path "$reference_path" ||
176 reference_path="$wt_prefix$reference_path"
177
178 reference="--reference=$reference_path"
179 fi
180
181 repo=$1
182 sm_path=$2
183
184 if test -z "$sm_path"; then
185 sm_path=$(printf '%s\n' "$repo" |
186 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
187 fi
188
189 if test -z "$repo" || test -z "$sm_path"; then
190 usage
191 fi
192
193 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
194
195 # assure repo is absolute or relative to parent
196 case "$repo" in
197 ./*|../*)
198 test -z "$wt_prefix" ||
199 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
200
201 # dereference source url relative to parent's url
202 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
203 ;;
204 *:*|/*)
205 # absolute url
206 realrepo=$repo
207 ;;
208 *)
209 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
210 ;;
211 esac
212
213 # normalize path:
214 # multiple //; leading ./; /./; /../; trailing /
215 sm_path=$(printf '%s/\n' "$sm_path" |
216 sed -e '
217 s|//*|/|g
218 s|^\(\./\)*||
219 s|/\(\./\)*|/|g
220 :start
221 s|\([^/]*\)/\.\./||
222 tstart
223 s|/*$||
224 ')
225 if test -z "$force"
226 then
227 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
228 die "$(eval_gettext "'\$sm_path' already exists in the index")"
229 else
230 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
231 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
232 fi
233
234 if test -z "$force" &&
235 ! git add --dry-run --ignore-missing --no-warn-embedded-repo "$sm_path" > /dev/null 2>&1
236 then
237 eval_gettextln "The following path is ignored by one of your .gitignore files:
238 \$sm_path
239 Use -f if you really want to add it." >&2
240 exit 1
241 fi
242
243 if test -n "$custom_name"
244 then
245 sm_name="$custom_name"
246 else
247 sm_name="$sm_path"
248 fi
249
250 if ! git submodule--helper check-name "$sm_name"
251 then
252 die "$(eval_gettext "'$sm_name' is not a valid submodule name")"
253 fi
254
255 # perhaps the path exists and is already a git repo, else clone it
256 if test -e "$sm_path"
257 then
258 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
259 then
260 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
261 else
262 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
263 fi
264
265 else
266 if test -d ".git/modules/$sm_name"
267 then
268 if test -z "$force"
269 then
270 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
271 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
272 die "$(eval_gettextln "\
273 If you want to reuse this local git directory instead of cloning again from
274 \$realrepo
275 use the '--force' option. If the local git directory is not the correct repo
276 or you are unsure what this means choose another name with the '--name' option.")"
277 else
278 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
279 fi
280 fi
281 git submodule--helper clone ${GIT_QUIET:+--quiet} ${progress:+"--progress"} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${dissociate:+"--dissociate"} ${depth:+"$depth"} || exit
282 (
283 sanitize_submodule_env
284 cd "$sm_path" &&
285 # ash fails to wordsplit ${branch:+-b "$branch"...}
286 case "$branch" in
287 '') git checkout -f -q ;;
288 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
289 esac
290 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
291 fi
292 git config submodule."$sm_name".url "$realrepo"
293
294 git add --no-warn-embedded-repo $force "$sm_path" ||
295 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
296
297 git submodule--helper config submodule."$sm_name".path "$sm_path" &&
298 git submodule--helper config submodule."$sm_name".url "$repo" &&
299 if test -n "$branch"
300 then
301 git submodule--helper config submodule."$sm_name".branch "$branch"
302 fi &&
303 git add --force .gitmodules ||
304 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
305
306 # NEEDSWORK: In a multi-working-tree world, this needs to be
307 # set in the per-worktree config.
308 if git config --get submodule.active >/dev/null
309 then
310 # If the submodule being adding isn't already covered by the
311 # current configured pathspec, set the submodule's active flag
312 if ! git submodule--helper is-active "$sm_path"
313 then
314 git config submodule."$sm_name".active "true"
315 fi
316 else
317 git config submodule."$sm_name".active "true"
318 fi
319 }
320
321 #
322 # Execute an arbitrary command sequence in each checked out
323 # submodule
324 #
325 # $@ = command to execute
326 #
327 cmd_foreach()
328 {
329 # parse $args after "submodule ... foreach".
330 while test $# -ne 0
331 do
332 case "$1" in
333 -q|--quiet)
334 GIT_QUIET=1
335 ;;
336 --recursive)
337 recursive=1
338 ;;
339 -*)
340 usage
341 ;;
342 *)
343 break
344 ;;
345 esac
346 shift
347 done
348
349 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper foreach ${GIT_QUIET:+--quiet} ${recursive:+--recursive} "$@"
350 }
351
352 #
353 # Register submodules in .git/config
354 #
355 # $@ = requested paths (default to all)
356 #
357 cmd_init()
358 {
359 # parse $args after "submodule ... init".
360 while test $# -ne 0
361 do
362 case "$1" in
363 -q|--quiet)
364 GIT_QUIET=1
365 ;;
366 --)
367 shift
368 break
369 ;;
370 -*)
371 usage
372 ;;
373 *)
374 break
375 ;;
376 esac
377 shift
378 done
379
380 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} "$@"
381 }
382
383 #
384 # Unregister submodules from .git/config and remove their work tree
385 #
386 cmd_deinit()
387 {
388 # parse $args after "submodule ... deinit".
389 deinit_all=
390 while test $# -ne 0
391 do
392 case "$1" in
393 -f|--force)
394 force=$1
395 ;;
396 -q|--quiet)
397 GIT_QUIET=1
398 ;;
399 --all)
400 deinit_all=t
401 ;;
402 --)
403 shift
404 break
405 ;;
406 -*)
407 usage
408 ;;
409 *)
410 break
411 ;;
412 esac
413 shift
414 done
415
416 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper deinit ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} ${force:+--force} ${deinit_all:+--all} "$@"
417 }
418
419 is_tip_reachable () (
420 sanitize_submodule_env &&
421 cd "$1" &&
422 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
423 test -z "$rev"
424 )
425
426 fetch_in_submodule () (
427 sanitize_submodule_env &&
428 cd "$1" &&
429 case "$2" in
430 '')
431 git fetch ;;
432 *)
433 shift
434 git fetch $(get_default_remote) "$@" ;;
435 esac
436 )
437
438 #
439 # Update each submodule path to correct revision, using clone and checkout as needed
440 #
441 # $@ = requested paths (default to all)
442 #
443 cmd_update()
444 {
445 # parse $args after "submodule ... update".
446 while test $# -ne 0
447 do
448 case "$1" in
449 -q|--quiet)
450 GIT_QUIET=1
451 ;;
452 -v)
453 GIT_QUIET=0
454 ;;
455 --progress)
456 progress=1
457 ;;
458 -i|--init)
459 init=1
460 ;;
461 --remote)
462 remote=1
463 ;;
464 -N|--no-fetch)
465 nofetch=1
466 ;;
467 -f|--force)
468 force=$1
469 ;;
470 -r|--rebase)
471 update="rebase"
472 ;;
473 --reference)
474 case "$2" in '') usage ;; esac
475 reference="--reference=$2"
476 shift
477 ;;
478 --reference=*)
479 reference="$1"
480 ;;
481 --dissociate)
482 dissociate=1
483 ;;
484 -m|--merge)
485 update="merge"
486 ;;
487 --recursive)
488 recursive=1
489 ;;
490 --checkout)
491 update="checkout"
492 ;;
493 --recommend-shallow)
494 recommend_shallow="--recommend-shallow"
495 ;;
496 --no-recommend-shallow)
497 recommend_shallow="--no-recommend-shallow"
498 ;;
499 --depth)
500 case "$2" in '') usage ;; esac
501 depth="--depth=$2"
502 shift
503 ;;
504 --depth=*)
505 depth=$1
506 ;;
507 -j|--jobs)
508 case "$2" in '') usage ;; esac
509 jobs="--jobs=$2"
510 shift
511 ;;
512 --jobs=*)
513 jobs=$1
514 ;;
515 --)
516 shift
517 break
518 ;;
519 -*)
520 usage
521 ;;
522 *)
523 break
524 ;;
525 esac
526 shift
527 done
528
529 if test -n "$init"
530 then
531 cmd_init "--" "$@" || return
532 fi
533
534 {
535 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
536 ${progress:+"--progress"} \
537 ${wt_prefix:+--prefix "$wt_prefix"} \
538 ${prefix:+--recursive-prefix "$prefix"} \
539 ${update:+--update "$update"} \
540 ${reference:+"$reference"} \
541 ${dissociate:+"--dissociate"} \
542 ${depth:+--depth "$depth"} \
543 $recommend_shallow \
544 $jobs \
545 "$@" || echo "#unmatched" $?
546 } | {
547 err=
548 while read -r quickabort sha1 just_cloned sm_path
549 do
550 die_if_unmatched "$quickabort" "$sha1"
551
552 git submodule--helper ensure-core-worktree "$sm_path" || exit 1
553
554 update_module=$(git submodule--helper update-module-mode $just_cloned "$sm_path" $update)
555
556 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
557
558 if test $just_cloned -eq 1
559 then
560 subsha1=
561 else
562 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
563 git rev-parse --verify HEAD) ||
564 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
565 fi
566
567 if test -n "$remote"
568 then
569 branch=$(git submodule--helper remote-branch "$sm_path")
570 if test -z "$nofetch"
571 then
572 # Fetch remote before determining tracking $sha1
573 fetch_in_submodule "$sm_path" $depth ||
574 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
575 fi
576 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
577 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
578 git rev-parse --verify "${remote_name}/${branch}") ||
579 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
580 fi
581
582 if test "$subsha1" != "$sha1" || test -n "$force"
583 then
584 subforce=$force
585 # If we don't already have a -f flag and the submodule has never been checked out
586 if test -z "$subsha1" && test -z "$force"
587 then
588 subforce="-f"
589 fi
590
591 if test -z "$nofetch"
592 then
593 # Run fetch only if $sha1 isn't present or it
594 # is not reachable from a ref.
595 is_tip_reachable "$sm_path" "$sha1" ||
596 fetch_in_submodule "$sm_path" $depth ||
597 say "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
598
599 # Now we tried the usual fetch, but $sha1 may
600 # not be reachable from any of the refs
601 is_tip_reachable "$sm_path" "$sha1" ||
602 fetch_in_submodule "$sm_path" $depth "$sha1" ||
603 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
604 fi
605
606 must_die_on_failure=
607 case "$update_module" in
608 checkout)
609 command="git checkout $subforce -q"
610 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
611 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
612 ;;
613 rebase)
614 command="git rebase"
615 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
616 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
617 must_die_on_failure=yes
618 ;;
619 merge)
620 command="git merge"
621 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
622 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
623 must_die_on_failure=yes
624 ;;
625 !*)
626 command="${update_module#!}"
627 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
628 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
629 must_die_on_failure=yes
630 ;;
631 *)
632 die "$(eval_gettext "Invalid update mode '$update_module' for submodule path '$path'")"
633 esac
634
635 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
636 then
637 say "$say_msg"
638 elif test -n "$must_die_on_failure"
639 then
640 die_with_status 2 "$die_msg"
641 else
642 err="${err};$die_msg"
643 continue
644 fi
645 fi
646
647 if test -n "$recursive"
648 then
649 (
650 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
651 wt_prefix=
652 sanitize_submodule_env
653 cd "$sm_path" &&
654 eval cmd_update
655 )
656 res=$?
657 if test $res -gt 0
658 then
659 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
660 if test $res -ne 2
661 then
662 err="${err};$die_msg"
663 continue
664 else
665 die_with_status $res "$die_msg"
666 fi
667 fi
668 fi
669 done
670
671 if test -n "$err"
672 then
673 OIFS=$IFS
674 IFS=';'
675 for e in $err
676 do
677 if test -n "$e"
678 then
679 echo >&2 "$e"
680 fi
681 done
682 IFS=$OIFS
683 exit 1
684 fi
685 }
686 }
687
688 #
689 # Configures a submodule's default branch
690 #
691 # $@ = requested path
692 #
693 cmd_set_branch() {
694 unset_branch=false
695 branch=
696
697 while test $# -ne 0
698 do
699 case "$1" in
700 -q|--quiet)
701 # we don't do anything with this but we need to accept it
702 ;;
703 -d|--default)
704 unset_branch=true
705 ;;
706 -b|--branch)
707 case "$2" in '') usage ;; esac
708 branch=$2
709 shift
710 ;;
711 --)
712 shift
713 break
714 ;;
715 -*)
716 usage
717 ;;
718 *)
719 break
720 ;;
721 esac
722 shift
723 done
724
725 if test $# -ne 1
726 then
727 usage
728 fi
729
730 # we can't use `git submodule--helper name` here because internally, it
731 # hashes the path so a trailing slash could lead to an unintentional no match
732 name="$(git submodule--helper list "$1" | cut -f2)"
733 if test -z "$name"
734 then
735 exit 1
736 fi
737
738 test -n "$branch"; has_branch=$?
739 test "$unset_branch" = true; has_unset_branch=$?
740
741 if test $((!$has_branch != !$has_unset_branch)) -eq 0
742 then
743 usage
744 fi
745
746 if test $has_branch -eq 0
747 then
748 git submodule--helper config submodule."$name".branch "$branch"
749 else
750 git submodule--helper config --unset submodule."$name".branch
751 fi
752 }
753
754 #
755 # Show commit summary for submodules in index or working tree
756 #
757 # If '--cached' is given, show summary between index and given commit,
758 # or between working tree and given commit
759 #
760 # $@ = [commit (default 'HEAD'),] requested paths (default all)
761 #
762 cmd_summary() {
763 summary_limit=-1
764 for_status=
765 diff_cmd=diff-index
766
767 # parse $args after "submodule ... summary".
768 while test $# -ne 0
769 do
770 case "$1" in
771 --cached)
772 cached="$1"
773 ;;
774 --files)
775 files="$1"
776 ;;
777 --for-status)
778 for_status="$1"
779 ;;
780 -n|--summary-limit)
781 summary_limit="$2"
782 isnumber "$summary_limit" || usage
783 shift
784 ;;
785 --summary-limit=*)
786 summary_limit="${1#--summary-limit=}"
787 isnumber "$summary_limit" || usage
788 ;;
789 --)
790 shift
791 break
792 ;;
793 -*)
794 usage
795 ;;
796 *)
797 break
798 ;;
799 esac
800 shift
801 done
802
803 test $summary_limit = 0 && return
804
805 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
806 then
807 head=$rev
808 test $# = 0 || shift
809 elif test -z "$1" || test "$1" = "HEAD"
810 then
811 # before the first commit: compare with an empty tree
812 head=$(git hash-object -w -t tree --stdin </dev/null)
813 test -z "$1" || shift
814 else
815 head="HEAD"
816 fi
817
818 if [ -n "$files" ]
819 then
820 test -n "$cached" &&
821 die "$(gettext "The --cached option cannot be used with the --files option")"
822 diff_cmd=diff-files
823 head=
824 fi
825
826 cd_to_toplevel
827 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
828 # Get modified modules cared by user
829 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
830 sane_egrep '^:([0-7]* )?160000' |
831 while read -r mod_src mod_dst sha1_src sha1_dst status sm_path
832 do
833 # Always show modules deleted or type-changed (blob<->module)
834 if test "$status" = D || test "$status" = T
835 then
836 printf '%s\n' "$sm_path"
837 continue
838 fi
839 # Respect the ignore setting for --for-status.
840 if test -n "$for_status"
841 then
842 name=$(git submodule--helper name "$sm_path")
843 ignore_config=$(get_submodule_config "$name" ignore none)
844 test $status != A && test $ignore_config = all && continue
845 fi
846 # Also show added or modified modules which are checked out
847 GIT_DIR="$sm_path/.git" git rev-parse --git-dir >/dev/null 2>&1 &&
848 printf '%s\n' "$sm_path"
849 done
850 )
851
852 test -z "$modules" && return
853
854 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
855 sane_egrep '^:([0-7]* )?160000' |
856 cut -c2- |
857 while read -r mod_src mod_dst sha1_src sha1_dst status name
858 do
859 if test -z "$cached" &&
860 is_zero_oid $sha1_dst
861 then
862 case "$mod_dst" in
863 160000)
864 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
865 ;;
866 100644 | 100755 | 120000)
867 sha1_dst=$(git hash-object $name)
868 ;;
869 000000)
870 ;; # removed
871 *)
872 # unexpected type
873 eval_gettextln "unexpected mode \$mod_dst" >&2
874 continue ;;
875 esac
876 fi
877 missing_src=
878 missing_dst=
879
880 test $mod_src = 160000 &&
881 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_src^0 >/dev/null &&
882 missing_src=t
883
884 test $mod_dst = 160000 &&
885 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_dst^0 >/dev/null &&
886 missing_dst=t
887
888 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
889
890 total_commits=
891 case "$missing_src,$missing_dst" in
892 t,)
893 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
894 ;;
895 ,t)
896 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
897 ;;
898 t,t)
899 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
900 ;;
901 *)
902 errmsg=
903 total_commits=$(
904 if test $mod_src = 160000 && test $mod_dst = 160000
905 then
906 range="$sha1_src...$sha1_dst"
907 elif test $mod_src = 160000
908 then
909 range=$sha1_src
910 else
911 range=$sha1_dst
912 fi
913 GIT_DIR="$name/.git" \
914 git rev-list --first-parent $range -- | wc -l
915 )
916 total_commits=" ($(($total_commits + 0)))"
917 ;;
918 esac
919
920 sha1_abbr_src=$(GIT_DIR="$name/.git" git rev-parse --short $sha1_src 2>/dev/null ||
921 echo $sha1_src | cut -c1-7)
922 sha1_abbr_dst=$(GIT_DIR="$name/.git" git rev-parse --short $sha1_dst 2>/dev/null ||
923 echo $sha1_dst | cut -c1-7)
924
925 if test $status = T
926 then
927 blob="$(gettext "blob")"
928 submodule="$(gettext "submodule")"
929 if test $mod_dst = 160000
930 then
931 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
932 else
933 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
934 fi
935 else
936 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
937 fi
938 if test -n "$errmsg"
939 then
940 # Don't give error msg for modification whose dst is not submodule
941 # i.e. deleted or changed to blob
942 test $mod_dst = 160000 && echo "$errmsg"
943 else
944 if test $mod_src = 160000 && test $mod_dst = 160000
945 then
946 limit=
947 test $summary_limit -gt 0 && limit="-$summary_limit"
948 GIT_DIR="$name/.git" \
949 git log $limit --pretty='format: %m %s' \
950 --first-parent $sha1_src...$sha1_dst
951 elif test $mod_dst = 160000
952 then
953 GIT_DIR="$name/.git" \
954 git log --pretty='format: > %s' -1 $sha1_dst
955 else
956 GIT_DIR="$name/.git" \
957 git log --pretty='format: < %s' -1 $sha1_src
958 fi
959 echo
960 fi
961 echo
962 done
963 }
964 #
965 # List all submodules, prefixed with:
966 # - submodule not initialized
967 # + different revision checked out
968 #
969 # If --cached was specified the revision in the index will be printed
970 # instead of the currently checked out revision.
971 #
972 # $@ = requested paths (default to all)
973 #
974 cmd_status()
975 {
976 # parse $args after "submodule ... status".
977 while test $# -ne 0
978 do
979 case "$1" in
980 -q|--quiet)
981 GIT_QUIET=1
982 ;;
983 --cached)
984 cached=1
985 ;;
986 --recursive)
987 recursive=1
988 ;;
989 --)
990 shift
991 break
992 ;;
993 -*)
994 usage
995 ;;
996 *)
997 break
998 ;;
999 esac
1000 shift
1001 done
1002
1003 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper status ${GIT_QUIET:+--quiet} ${cached:+--cached} ${recursive:+--recursive} "$@"
1004 }
1005 #
1006 # Sync remote urls for submodules
1007 # This makes the value for remote.$remote.url match the value
1008 # specified in .gitmodules.
1009 #
1010 cmd_sync()
1011 {
1012 while test $# -ne 0
1013 do
1014 case "$1" in
1015 -q|--quiet)
1016 GIT_QUIET=1
1017 shift
1018 ;;
1019 --recursive)
1020 recursive=1
1021 shift
1022 ;;
1023 --)
1024 shift
1025 break
1026 ;;
1027 -*)
1028 usage
1029 ;;
1030 *)
1031 break
1032 ;;
1033 esac
1034 done
1035
1036 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper sync ${GIT_QUIET:+--quiet} ${recursive:+--recursive} "$@"
1037 }
1038
1039 cmd_absorbgitdirs()
1040 {
1041 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
1042 }
1043
1044 # This loop parses the command line arguments to find the
1045 # subcommand name to dispatch. Parsing of the subcommand specific
1046 # options are primarily done by the subcommand implementations.
1047 # Subcommand specific options such as --branch and --cached are
1048 # parsed here as well, for backward compatibility.
1049
1050 while test $# != 0 && test -z "$command"
1051 do
1052 case "$1" in
1053 add | foreach | init | deinit | update | set-branch | status | summary | sync | absorbgitdirs)
1054 command=$1
1055 ;;
1056 -q|--quiet)
1057 GIT_QUIET=1
1058 ;;
1059 -b|--branch)
1060 case "$2" in
1061 '')
1062 usage
1063 ;;
1064 esac
1065 branch="$2"; shift
1066 ;;
1067 --cached)
1068 cached="$1"
1069 ;;
1070 --)
1071 break
1072 ;;
1073 -*)
1074 usage
1075 ;;
1076 *)
1077 break
1078 ;;
1079 esac
1080 shift
1081 done
1082
1083 # No command word defaults to "status"
1084 if test -z "$command"
1085 then
1086 if test $# = 0
1087 then
1088 command=status
1089 else
1090 usage
1091 fi
1092 fi
1093
1094 # "-b branch" is accepted only by "add" and "set-branch"
1095 if test -n "$branch" && (test "$command" != add || test "$command" != set-branch)
1096 then
1097 usage
1098 fi
1099
1100 # "--cached" is accepted only by "status" and "summary"
1101 if test -n "$cached" && test "$command" != status && test "$command" != summary
1102 then
1103 usage
1104 fi
1105
1106 "cmd_$(echo $command | sed -e s/-/_/g)" "$@"